package cn.ey.biz.module.system.service.field;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.controller.admin.field.vo.*;
import cn.ey.biz.module.system.dal.dataobject.field.FieldItemDO;

import java.util.*;
import javax.validation.*;

/**
 * 字段条目 Service 接口
 *
 */
public interface FieldItemService {

    /**
     * 创建字段条目
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createFieldItem(@Valid FieldItemCreateReqVO createReqVO);

    /**
     * 更新字段条目
     *
     * @param updateReqVO 更新信息
     */
    void updateFieldItem(@Valid FieldItemUpdateReqVO updateReqVO);

    /**
     * 删除字段条目
     *
     * @param id 编号
     */
    void deleteFieldItem(Long id);

    /**
     * 获得字段条目
     *
     * @param id 编号
     * @return 字段条目
     */
    FieldItemDO getFieldItem(Long id);

    /**
     * 获得字段条目列表
     *
     * @param ids 编号
     * @return 字段条目列表
     */
    List<FieldItemDO> getFieldItemList(Collection<Long> ids);

    /**
     * 获得字段条目分页
     *
     * @param pageReqVO 分页查询
     * @return 字段条目分页
     */
    PageResult<FieldItemDO> getFieldItemPage(FieldItemPageReqVO pageReqVO);

    /**
     * 获得字段条目列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 字段条目列表
     */
    List<FieldItemDO> getFieldItemList(FieldItemExportReqVO exportReqVO);

    void updateFieldItemBelongto(FieldItemUpdateReqVO updateReqVO);
}
